/*-
 * Copyright (C) @BABOLO  2002 Dec 04
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2002 Dec 04\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cmd_binselect.c,v 1.1 2002/12/16 23:42:47 babolo Exp $";
#endif /* not lint */
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <libpq-fe.h>
#include "pgoblin.h"

static const char *fetchN[] =
{ "FETCH 1 FROM pgobin"
, "FETCH 2 FROM pgobin"
, "FETCH 3 FROM pgobin"
, "FETCH 5 FROM pgobin"
, "FETCH 8 FROM pgobin"
, "FETCH 13 FROM pgobin"
, "FETCH 21 FROM pgobin"
, "FETCH 34 FROM pgobin"
, "FETCH 55 FROM pgobin"
, "FETCH 89 FROM pgobin"
, "FETCH 144 FROM pgobin"
, "FETCH 233 FROM pgobin"
, "FETCH 377 FROM pgobin"
, "FETCH 610 FROM pgobin"
, "FETCH 987 FROM pgobin"
, "FETCH 1597 FROM pgobin"
, "FETCH 2584 FROM pgobin"
, "FETCH 4181 FROM pgobin"
, "FETCH 6765 FROM pgobin"
, "FETCH 10946 FROM pgobin"
, "FETCH 17711 FROM pgobin"
, NULL
};

int
binselect(struct connopt *options, FILE *out) {
    int j, c, k, t, f;
    PGresult *res;
    size_t i;

    if  (shurecon(options)) return(-1);
    if  (!options->intran) {
        PQEXEC(res, "BEGIN", PGRES_COMMAND_OK, -1);
        PQclear(res);
    }
    PQEXEC(res, options->query, PGRES_COMMAND_OK, -1);
    PQclear(res);
    i = 0;
    PQEXEC(res, fetchN[i], PGRES_TUPLES_OK, -1);
    for (; (t = PQntuples(res)) > 0 && !feof(out) && !ferror(out); ) {
        for (j = 0, k = 0; k < t && !feof(out) && !ferror(out); k++) {
            for (c = 0; c < PQnfields(res) && !feof(out) && !ferror(out); c++) {
                if  (!PQgetisnull(res, k, c)) {
                    fwrite(PQgetvalue(res, k, c), (f = PQgetlength(res, k, c)), 1, out);
                    j += f;
        }   }   }
        PQclear(res);
        if  (v_flag > 2) fprintf(stderr, "j=%d aim=%d i %d => ", j, BUFMULT * BUFSIZE, i);
        if  (j > BUFMULT * BUFSIZE && i > 0) i--;
        if  (j < BUFMULT * BUFSIZE && fetchN[i + 1]) i++;
        if  (v_flag > 2) fprintf(stderr, "%d\n", i);
        PQEXEC(res, fetchN[i], PGRES_TUPLES_OK, -1)
    }
    PQclear(res);
    if  (!options->intran) {
        PQEXEC(res, "END", PGRES_COMMAND_OK, -1);
        PQclear(res);
    }
    return(0);
}
