/*-
 * Copyright (C) @BABOLO  2002 Dec 04
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pgoblin.h,v 1.1 2002/12/16 23:42:47 babolo Exp $
 */

#define BUFSIZE 8192
#define BUFMULT 2
#define PQEXEC(RESULT, QUERY, CONDITION, CCODE) {                                                    \
    if  (v_flag > 2) fprintf(stderr, "PQexec: %s\n", QUERY);                                         \
    RESULT = PQexec(options->conn, QUERY);                                                           \
    if  (!RESULT) {                                                                                  \
        if (v_flag >= 0)                                  warnx("result is absent - fatal error.\n");\
        return(CCODE);                                                                               \
    }                                                                                                \
    if  (v_flag > 2) fprintf(stderr, "PQresultStatus %d\n", PQresultStatus(res));                    \
    if  (PQresultStatus(res) != CONDITION) {                                                         \
        if (v_flag >= 0)                    warnx("PQexec failed: %s", PQresultErrorMessage(RESULT));\
        return(CCODE);                                                                               \
}   }

enum command {cmd_null, cmd_copyin, cmd_copyout, cmd_perform, cmd_binselect, cmd_strselect};

struct connopt{
    char   *dbname;
    char   *host;
    char   *port;
    char   *username;
    PGconn *conn;
    char   *query;
    enum command cmd;
    u_char intran;
};

char         * prefile __P((FILE *, char *, char *));
int           shurecon __P((struct connopt *));
int          binselect __P((struct connopt *, FILE *));
PGresult * strselect_q __P((struct connopt *));
int        strselect_p __P((PGresult *, FILE *));

extern int v_flag;
